package io.ient.test;

import io.ient.test.context.FrameworkTestBase;
import io.ient.test.facets.Login;
import io.ient.test.framework.selenium.WaitTime;
import io.ient.test.framework.utils.DateUtils;
import io.ient.test.framework.utils.RandomDataUtils;
import io.ient.test.framework.utils.annotations.TestCaseID;
import io.ient.test.pages.HomePage;
import io.ient.test.pages.enterprise.*;
import org.testng.annotations.Test;
import org.testng.asserts.SoftAssert;

public class ProblemCaseTest extends FrameworkTestBase {

    @TestCaseID(ids = {"IENT-754" , "IENT-772"})
    @Test
    public void verifyProblemCaseApprovalWorkflow() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerUser(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnSupplyChainIssueManagement();
        ProblemCasePage problemCasePage = new ProblemCasePage(driver);
        String problemType = "1";
        String primaryNonConformance = "1";
        String secondaryNonConformance = "1";
        String part = "1";
        String buyerLocation = "1";
        String caseStatus = "open";
        String priority = "P1";
        String supplierLocation = "1";
        String supplier = "1";
        String shortDescription = RandomDataUtils.randomNumeric(5);
        problemCasePage.createProblemCase(problemType, primaryNonConformance, secondaryNonConformance, part, buyerLocation, caseStatus, priority, supplierLocation, shortDescription, supplier);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        String problemCaseId = problemCasePage.getProblemCaseId();
        String conversationComment = RandomDataUtils.randomAlphabetic(5);
        String problemDescription = RandomDataUtils.randomAlphabetic(5);
        String productionPhase = "1";
        String problemQualifier = "1";
        String submittedSupplierStatus = "Submitted to Supplier";
        problemCasePage.editProblemCase(conversationComment, problemDescription, productionPhase, problemQualifier, submittedSupplierStatus);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseCreatedAndEdited = problemCasePage.isProblemCaseDisplayed(problemCaseId, submittedSupplierStatus);
        softAssert.assertTrue(isProblemCaseCreatedAndEdited, "Failed to create and edit problem case");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseDisplayedWithSubmittedSupplierStatus = problemCasePage.isProblemCaseDisplayed(problemCaseId, submittedSupplierStatus);
        softAssert.assertTrue(isProblemCaseDisplayedWithSubmittedSupplierStatus, "Failed to display problem case with Submitted to Supplier status in supplier admin");
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String initialResponseFromSupplierStatus = "Initial response from supplier";
        String initialResponseFromTheSupplierStatus = "Initial response from the supplier";
        problemCasePage.editProblemCase(conversationComment, initialResponseFromSupplierStatus);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseDisplayedWithInitialResponseFromSupplierStatus = problemCasePage.isProblemCaseDisplayed(problemCaseId, initialResponseFromTheSupplierStatus);
        softAssert.assertTrue(isProblemCaseDisplayedWithInitialResponseFromSupplierStatus, "Failed to display problem case with Initial response from supplier status in supplier admin");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseDisplayedWithInitialResponseFromSupplierStatusBU = problemCasePage.isProblemCaseDisplayed(problemCaseId, initialResponseFromTheSupplierStatus);
        softAssert.assertTrue(isProblemCaseDisplayedWithInitialResponseFromSupplierStatusBU, "Failed to display problem case with Initial response from supplier status in buyer user");
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String resubmitForAdditionalResponsesStatus = "Re-submit for additional responses to supplier";
        problemCasePage.editProblemCase(conversationComment, resubmitForAdditionalResponsesStatus);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseDisplayedWithResubmitForAdditionalResponsesStatus = problemCasePage.isProblemCaseDisplayed(problemCaseId, resubmitForAdditionalResponsesStatus);
        softAssert.assertTrue(isProblemCaseDisplayedWithResubmitForAdditionalResponsesStatus, "Failed to display problem case with Re-submit for additional responses to supplier status in buyer user");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseDisplayedWithResubmitForAdditionalResponsesStatusSA = problemCasePage.isProblemCaseDisplayed(problemCaseId, resubmitForAdditionalResponsesStatus);
        softAssert.assertTrue(isProblemCaseDisplayedWithResubmitForAdditionalResponsesStatusSA, "Failed to display problem case with Re-submit for additional responses to supplier status in suppler admin");
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String finalResponseFromSupplierStatus = "Final response from supplier";
        problemCasePage.editProblemCase(conversationComment, finalResponseFromSupplierStatus);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseDisplayedWithFinalResponseFromSupplierStatus = problemCasePage.isProblemCaseDisplayed(problemCaseId, finalResponseFromSupplierStatus);
        softAssert.assertTrue(isProblemCaseDisplayedWithFinalResponseFromSupplierStatus, "Failed to display problem case with Final response from supplier status in suppler admin");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseDisplayedWithFinalResponseFromSupplierStatusBU = problemCasePage.isProblemCaseDisplayed(problemCaseId, finalResponseFromSupplierStatus);
        softAssert.assertTrue(isProblemCaseDisplayedWithFinalResponseFromSupplierStatusBU, "Failed to display problem case with Final response from supplier status in buyer user");
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String approveFinalResponseFromSupplier = "Approve final response from supplier";
        String finalStatus = "Closed Complete";
        problemCasePage.editProblemCase(conversationComment, approveFinalResponseFromSupplier);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseDisplayedWithFinalStatus = problemCasePage.isProblemCaseDisplayed(problemCaseId, finalStatus);
        softAssert.assertTrue(isProblemCaseDisplayedWithFinalStatus, "Failed to display problem case with Closed Complete status in buyer user");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"T3943"})
    @Test
    public void verifyProblemCaseWorkflowRejection() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerUser(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnSupplyChainIssueManagement();
        ProblemCasePage problemCasePage = new ProblemCasePage(driver);
        String problemType = "1";
        String primaryNonConformance = "1";
        String secondaryNonConformance = "1";
        String part = "1";
        String buyerLocation = "1";
        String caseStatus = "open";
        String priority = "P1";
        String supplierLocation = "1";
        String supplier = "1";
        String shortDescription = RandomDataUtils.randomNumeric(5);
        problemCasePage.createProblemCase(problemType, primaryNonConformance, secondaryNonConformance, part, buyerLocation, caseStatus, priority, supplierLocation, shortDescription, supplier);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        String problemCaseId = problemCasePage.getProblemCaseId();
        String conversationComment = RandomDataUtils.randomNumeric(5);
        String problemDescription = RandomDataUtils.randomNumeric(5);
        String productionPhase = "1";
        String problemQualifier = "1";
        String submittedSupplierStatus = "Submitted to Supplier";
        problemCasePage.editProblemCase(conversationComment, problemDescription, productionPhase, problemQualifier, submittedSupplierStatus);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseCreatedAndEdited = problemCasePage.isProblemCaseDisplayed(problemCaseId, submittedSupplierStatus);
        softAssert.assertTrue(isProblemCaseCreatedAndEdited, "Failed to create and edit problem case");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseDisplayedWithSubmittedSupplierStatus = problemCasePage.isProblemCaseDisplayed(problemCaseId, submittedSupplierStatus);
        softAssert.assertTrue(isProblemCaseDisplayedWithSubmittedSupplierStatus, "Failed to display problem case with Submitted to Supplier status in supplier admin");
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String initialResponseFromSupplierStatus = "Initial response from supplier";
        problemCasePage.editProblemCase(conversationComment, initialResponseFromSupplierStatus);
        String initialResponseFromTheSupplierStatus = "Initial response from the supplier";
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseDisplayedWithInitialResponseFromSupplierStatus = problemCasePage.isProblemCaseDisplayed(problemCaseId, initialResponseFromTheSupplierStatus);
        softAssert.assertTrue(isProblemCaseDisplayedWithInitialResponseFromSupplierStatus, "Failed to display problem case with Initial response from supplier status in supplier admin");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseDisplayedWithInitialResponseFromSupplierStatusBU = problemCasePage.isProblemCaseDisplayed(problemCaseId, initialResponseFromTheSupplierStatus);
        softAssert.assertTrue(isProblemCaseDisplayedWithInitialResponseFromSupplierStatusBU, "Failed to display problem case with Initial response from supplier status in buyer user");
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String resubmitForAdditionalResponsesStatus = "Re-submit for additional responses to supplier";
        problemCasePage.editProblemCase(conversationComment, resubmitForAdditionalResponsesStatus);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseDisplayedWithResubmitForAdditionalResponsesStatus = problemCasePage.isProblemCaseDisplayed(problemCaseId, resubmitForAdditionalResponsesStatus);
        softAssert.assertTrue(isProblemCaseDisplayedWithResubmitForAdditionalResponsesStatus, "Failed to display problem case with Re-submit for additional responses to supplier status in buyer user");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseDisplayedWithResubmitForAdditionalResponsesStatusSA = problemCasePage.isProblemCaseDisplayed(problemCaseId, resubmitForAdditionalResponsesStatus);
        softAssert.assertTrue(isProblemCaseDisplayedWithResubmitForAdditionalResponsesStatusSA, "Failed to display problem case with Re-submit for additional responses to supplier status in suppler admin");
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String finalResponseFromSupplierStatus = "Final response from supplier";
        problemCasePage.editProblemCase(conversationComment, finalResponseFromSupplierStatus);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseDisplayedWithFinalResponseFromSupplierStatus = problemCasePage.isProblemCaseDisplayed(problemCaseId, finalResponseFromSupplierStatus);
        softAssert.assertTrue(isProblemCaseDisplayedWithFinalResponseFromSupplierStatus, "Failed to display problem case with Final response from supplier status in suppler admin");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseDisplayedWithFinalResponseFromSupplierStatusBU = problemCasePage.isProblemCaseDisplayed(problemCaseId, finalResponseFromSupplierStatus);
        softAssert.assertTrue(isProblemCaseDisplayedWithFinalResponseFromSupplierStatusBU, "Failed to display problem case with Final response from supplier status in buyer user");
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String rejectFinalResponseFromSupplier = "Reject final response from the supplier";
        String finalStatus = "Closed Incomplete";
        problemCasePage.editProblemCase(conversationComment, rejectFinalResponseFromSupplier);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseDisplayedWithFinalStatus = problemCasePage.isProblemCaseDisplayed(problemCaseId, finalStatus);
        softAssert.assertTrue(isProblemCaseDisplayedWithFinalStatus, "Failed to display problem case with Closed Complete status in buyer user");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"T3944"})
    @Test
    public void verifyProblemCaseUpdateBuyerAction() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerUser(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnSupplyChainIssueManagement();
        ProblemCasePage problemCasePage = new ProblemCasePage(driver);
        String problemType = "1";
        String primaryNonConformance = "1";
        String secondaryNonConformance = "1";
        String part = "1";
        String buyerLocation = "1";
        String caseStatus = "open";
        String priority = "P1";
        String supplierLocation = "1";
        String supplier = "1";
        String shortDescription = RandomDataUtils.randomNumeric(5);
        problemCasePage.createProblemCase(problemType, primaryNonConformance, secondaryNonConformance, part, buyerLocation, caseStatus, priority, supplierLocation, shortDescription, supplier);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.clickOnCaseFormVerticalButton();
        problemCasePage.updateBuyer();
        driver.sleep(WaitTime.SMALL_WAIT);
        String buyerAdminUserName = testContext.app.getBuyerAdminUser();
        problemCasePage.searchUser(buyerAdminUserName);
        driver.sleep(WaitTime.SMALL_WAIT);
        boolean isProblemCaseAssigned = problemCasePage.isOwnerAssigned(buyerAdminUserName);
        softAssert.assertTrue(isProblemCaseAssigned, "Failed to assign problem case to buyer admin");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"T3945"})
    @Test
    public void verifyProblemCaseAssignSupplierAction() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerUser(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnSupplyChainIssueManagement();
        ProblemCasePage problemCasePage = new ProblemCasePage(driver);
        String problemType = "1";
        String primaryNonConformance = "1";
        String secondaryNonConformance = "1";
        String part = "1";
        String buyerLocation = "1";
        String caseStatus = "open";
        String priority = "P1";
        String supplierLocation = "1";
        String supplier = "1";
        String shortDescription = RandomDataUtils.randomNumeric(5);
        problemCasePage.createProblemCase(problemType, primaryNonConformance, secondaryNonConformance, part, buyerLocation, caseStatus, priority, supplierLocation, shortDescription, supplier);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.clickOnCaseFormVerticalButton();
        problemCasePage.updateSupplier();
        driver.sleep(WaitTime.SMALL_WAIT);
        String supplierAdminUserName = testContext.app.getSupplierAdminUser();
        problemCasePage.searchUser(supplierAdminUserName);
        driver.sleep(WaitTime.SMALL_WAIT);
        boolean isProblemCaseAssigned = problemCasePage.isSupplierAssigned(supplierAdminUserName);
        softAssert.assertTrue(isProblemCaseAssigned, "Failed to assign problem case to supplier admin");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-1366"})
    @Test
    public void verifyProblemCaseAssignSupplierActionByBuyerAdmin() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerUser(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnSupplyChainIssueManagement();
        ProblemCasePage problemCasePage = new ProblemCasePage(driver);
        String problemType = "1";
        String primaryNonConformance = "1";
        String secondaryNonConformance = "1";
        String part = "1";
        String buyerLocation = "1";
        String caseStatus = "open";
        String priority = "P1";
        String supplierLocation = "1";
        String supplier = "1";
        String shortDescription = RandomDataUtils.randomNumeric(5);
        problemCasePage.createProblemCase(problemType, primaryNonConformance, secondaryNonConformance, part, buyerLocation, caseStatus, priority, supplierLocation, shortDescription, supplier);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String problemCaseId = problemCasePage.getProblemCaseId();
        String conversationComment = RandomDataUtils.randomAlphabetic(5);
        String problemDescription = RandomDataUtils.randomAlphabetic(5);
        String productionPhase = "1";
        String problemQualifier = "1";
        String submittedSupplierStatus = "Submitted to Supplier";
        String submittedSupplierStatusOptionValue = "submittedToSupplier";
        problemCasePage.editProblemCase(conversationComment, problemDescription, productionPhase, problemQualifier, submittedSupplierStatus);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseCreatedAndEdited = problemCasePage.isProblemCaseDisplayed(problemCaseId, submittedSupplierStatus);
        softAssert.assertTrue(isProblemCaseCreatedAndEdited, "Failed to create and edit problem case");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseDisplayedWithSubmittedSupplierStatus = problemCasePage.isProblemCaseDisplayed(problemCaseId, submittedSupplierStatus);
        softAssert.assertTrue(isProblemCaseDisplayedWithSubmittedSupplierStatus, "Failed to display problem case with Submitted to Supplier status in supplier admin");
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.clickOnCaseFormVerticalButton();
        problemCasePage.updateSupplier();
        driver.sleep(WaitTime.SMALL_WAIT);
        String supplierUserName = testContext.app.getSupplierUser();
        problemCasePage.searchUser(supplierUserName);
        driver.sleep(WaitTime.SMALL_WAIT);
        boolean isProblemCaseAssigned = problemCasePage.isSupplierAssigned(supplierUserName);
        softAssert.assertTrue(isProblemCaseAssigned, "Failed to assign problem case to supplier user");
        softAssert.assertAll();
    }

//    @TestCaseID(ids = {"T3946"})
//    @Test
//    public void verifyProblemCaseExtendDueDateAction() {
//        SoftAssert softAssert = new SoftAssert();
//        Login login = new Login(driver);
//        login.loginWithBuyerUser(testContext.app);
//        HomePage homePage = new HomePage(driver);
//        homePage.clickOnSupplyChainIssueManagement();
//        ProblemCasePage problemCasePage = new ProblemCasePage(driver);
//        String problemType = "1";
//        String primaryNonConformance = "1";
//        String secondaryNonConformance = "1";
//        String part = "1";
//        String buyerLocation = "1";
//        String caseStatus = "open";
//        String priority = "P1";
//        String supplierLocation = "1";
//        String shortDescription = RandomDataUtils.randomNumeric(5);
//        String supplier = "1";
//        problemCasePage.createProblemCase(problemType, primaryNonConformance, secondaryNonConformance, part, buyerLocation, caseStatus, priority, supplierLocation, shortDescription, supplier);
//        driver.sleep(WaitTime.LONG_WAIT);
//        driver.refresh();
//        driver.sleep(WaitTime.LONG_WAIT);
//        String problemCaseId = problemCasePage.getProblemCaseId();
//        problemCasePage.clickOnCaseFormVerticalButton();
//        problemCasePage.extendDueDate();
//        String date = DateUtils.getFormattedDateWithTimeZone(2,"dd","IST");
//        String dayName = DateUtils.getFormattedDateWithTimeZone(2,"EEE","IST");
//        dayName = dayName.substring(0, dayName.length() - 1);
//        String hour = "5:00 AM";
//        String minute = "5:05 AM";
//        String day = DateUtils.getFormattedDateWithTimeZone(2,"/MM/yyyy","IST");
//        String expectedDate = dayName + day + " 5:05:00 am";
//        problemCasePage.extendDueDate(date, hour, minute);
//        driver.sleep(WaitTime.LONG_WAIT);
//        driver.refresh();
//        driver.sleep(WaitTime.LONG_WAIT);
//        homePage.clickOnHome();
//        homePage.clickOnSupplyChainIssueManagement();
//        driver.sleep(WaitTime.MEDIUM_WAIT);
//        problemCasePage.searchProblemCaseByID(problemCaseId);
//        driver.sleep(WaitTime.SMALL_WAIT);
//        boolean isProblemCaseDueDateDisplayed = problemCasePage.isProblemCaseDueDateDisplayed(problemCaseId, expectedDate);
//        softAssert.assertTrue(isProblemCaseDueDateDisplayed, "Failed to display problem case with extended due date");
//        softAssert.assertAll();
//    }

    @TestCaseID(ids = {"IENT-751" , "IENT-1887"})
    @Test
    public void verifyCancelProblemCaseAndDelegationFeatureForClosedProblemCase() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerUser(testContext.app);
        String buyerUserName = testContext.app.getBuyerUser();
        HomePage homePage = new HomePage(driver);
        homePage.clickOnSupplyChainIssueManagement();
        ProblemCasePage problemCasePage = new ProblemCasePage(driver);
        AuditLogPage auditLogPage = new AuditLogPage(driver);
        String problemType = "1";
        String primaryNonConformance = "1";
        String secondaryNonConformance = "1";
        String part = "1";
        String buyerLocation = "1";
        String caseStatus = "open";
        String priority = "P1";
        String supplierLocation = "1";
        String supplier = "1";
        String shortDescription = RandomDataUtils.randomAlphabetic(5);
        problemCasePage.createProblemCase(problemType, primaryNonConformance, secondaryNonConformance, part, buyerLocation, caseStatus, priority, supplierLocation, shortDescription, supplier);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        boolean isDelegationFeatureDisplayed = problemCasePage.isDelegationFeatureDisplayed();
        softAssert.assertTrue(isDelegationFeatureDisplayed, "Failed to delegation feature");
        String problemCaseId = problemCasePage.getProblemCaseId();
        driver.sleep(WaitTime.SMALL_WAIT);
        String conversationComment = RandomDataUtils.randomAlphabetic(5);
        String problemDescription = RandomDataUtils.randomAlphabetic(5);
        String productionPhase = "1";
        String problemQualifier = "1";
        String submittedSupplierStatus = "Cancel Problem";
        problemCasePage.editProblemCase(conversationComment, problemDescription, productionPhase, problemQualifier, submittedSupplierStatus);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseCreatedAndEdited = problemCasePage.isProblemCaseDisplayed(problemCaseId, submittedSupplierStatus);
        softAssert.assertTrue(isProblemCaseCreatedAndEdited, "Failed to cancel problem case");
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        boolean isDelegationFeatureNotDisplayed = problemCasePage.isDelegationFeatureDisplayed();
        softAssert.assertFalse(isDelegationFeatureNotDisplayed, "Delegation feature is displayed");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnEnterprise();
        auditLogPage.clickOnAuditLogTab();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        auditLogPage.searchById(problemCaseId);
        driver.sleep(WaitTime.SMALL_WAIT);
        String action = "CREATE";
        boolean entityDisplayStatus = auditLogPage.isProblemCaseLogDisplayed(problemCaseId, buyerUserName, action);
        softAssert.assertTrue(entityDisplayStatus, "Failed to generate log for problem case creation");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-544"})
    @Test
    public void verifyProblemCasePageFeatures() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerUser(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnSupplyChainIssueManagement();
        ProblemCasePage problemCasePage = new ProblemCasePage(driver);
        boolean isSearchBarDisplayed = problemCasePage.isSearchBarDisplayed();
        softAssert.assertTrue(isSearchBarDisplayed, "Failed to display searchbar");
        boolean isSelectColumnsDisplayed = problemCasePage.isSelectColumnsDisplayed();
        softAssert.assertTrue(isSelectColumnsDisplayed, "Failed to display select columns");
        boolean isFilterIconDisplayed = problemCasePage.isFilterIconDisplayed();
        softAssert.assertTrue(isFilterIconDisplayed, "Failed to display filter");
        problemCasePage.clickOnTopLeftVerticalIcon();
        boolean isAddNewButtonDisplayed = problemCasePage.isAddNewButtonDisplayed();
        softAssert.assertTrue(isAddNewButtonDisplayed, "Failed to display Add New Button");
        boolean isDownloadAsPdfDisplayed = problemCasePage.isDownloadAsPdfDisplayed();
        softAssert.assertTrue(isDownloadAsPdfDisplayed, "Failed to display DownloadAsPdf");
        boolean isDownloadAsCsvDisplayed = problemCasePage.isDownloadAsCsvDisplayed();
        softAssert.assertTrue(isDownloadAsCsvDisplayed, "Failed to display DownloadAsCSV");
        boolean isNumberOfItemsPerPageEditable = problemCasePage.isNumberOfItemsPerPageEditable();
        softAssert.assertTrue(isNumberOfItemsPerPageEditable, "Failed to edit number of items per page");
        boolean isPaginationDisplayed = problemCasePage.isPaginationDisplayed();
        softAssert.assertTrue(isPaginationDisplayed, "Failed to display pagination");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-776"})
    @Test
    public void verifyHomePageFeatures() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerAdmin(testContext.app);
        HomePage homePage = new HomePage(driver);
        boolean isHomeButtonDisplayed = homePage.isHomeButtonDisplayed();
        softAssert.assertTrue(isHomeButtonDisplayed, "Failed to home button");
        boolean isTodoButtonDisplayed = homePage.isToDoButtonDisplayed();
        softAssert.assertTrue(isTodoButtonDisplayed, "Failed to todo button");
        boolean isAnalyticsButtonDisplayed = homePage.isAnalyticsButtonDisplayed();
        softAssert.assertTrue(isAnalyticsButtonDisplayed, "Failed to analytics button");
        boolean isProjectButtonDisplayed = homePage.isProjectButtonDisplayed();
        softAssert.assertTrue(isProjectButtonDisplayed, "Failed to project button");
        boolean isSettingsButtonDisplayed = homePage.isEnterPriseButtonDisplayed();
        softAssert.assertTrue(isSettingsButtonDisplayed, "Failed to settings button");
        homePage.clickOnSupplyChainIssueManagement();
        boolean isSearchBarDisplayed = homePage.isProblemCaseAddButtonDisplayed();
        softAssert.assertFalse(isSearchBarDisplayed, "Displayed add problem case button for buyer admin login");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-1182", "IENT-1309"})
    @Test
    public void verifyBuyerUserProblemCaseDetailsInSupplierUserAndSupplierAdminLogin() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerUser(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnSupplyChainIssueManagement();
        ProblemCasePage problemCasePage = new ProblemCasePage(driver);
        String problemType = "1";
        String primaryNonConformance = "1";
        String secondaryNonConformance = "1";
        String part = "1";
        String buyerLocation = "1";
        String caseStatus = "open";
        String priority = "P1";
        String supplierLocation = "1";
        String supplier = "1";
        String shortDescription = RandomDataUtils.randomNumeric(5);
        problemCasePage.createProblemCase(problemType, primaryNonConformance, secondaryNonConformance, part, buyerLocation, caseStatus, priority, supplierLocation, shortDescription, supplier);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        String problemCaseId = problemCasePage.getProblemCaseId();
        String problemCaseStatus = "Open Problem Case";
        homePage.clickOnHome();
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        driver.sleep(WaitTime.SMALL_WAIT);
        boolean isProblemCaseCreatedAndEdited = problemCasePage.isProblemCaseDisplayed(problemCaseId, problemCaseStatus);
        softAssert.assertTrue(isProblemCaseCreatedAndEdited, "Failed to create problem case");
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.clickOnCaseFormVerticalButton();
        problemCasePage.updateSupplier();
        String supplierAdminUserName = testContext.app.getSupplierAdminUser();
        String supplierUserName = testContext.app.getSupplierUser();
        String buyerUserName = testContext.app.getBuyerUser();
        String buyerAdminName = testContext.app.getBuyerAdminUser();
        softAssert.assertTrue(problemCasePage.isUserSearched(supplierAdminUserName), "Failed to search supplier admin");
        softAssert.assertTrue(problemCasePage.isUserSearched(supplierUserName), "Failed to search supplier user");
        softAssert.assertFalse(problemCasePage.isUserSearched(buyerUserName), "Failed to search buyer user");
        softAssert.assertFalse(problemCasePage.isUserSearched(buyerAdminName), "Failed to search buyer admin");
        problemCasePage.clickOnSearchUserCancelButton();
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        driver.sleep(WaitTime.SMALL_WAIT);
        boolean isProblemCaseDisplayedForSupplierAdmin = problemCasePage.isProblemCaseDisplayed(problemCaseId, problemCaseStatus);
        softAssert.assertTrue(isProblemCaseDisplayedForSupplierAdmin, "Failed to display problem case for supplier admin");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        login.loginWithSupplierUser(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        driver.sleep(WaitTime.SMALL_WAIT);
        boolean isProblemCaseDisplayedForSupplierUser = problemCasePage.isProblemCaseDisplayed(problemCaseId, problemCaseStatus);
        softAssert.assertTrue(isProblemCaseDisplayedForSupplierUser, "Failed to display problem case for supplier user");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-1512"})
    @Test
    public void verifyProblemCaseWithLocalVersion() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        HomePage homePage = new HomePage(driver);
        SupplyChainIssueMgmtPage supplyChainIssueMgmtPage = new SupplyChainIssueMgmtPage(driver);
        UserManagementPage userManagementPage = new UserManagementPage(driver);
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnProject();
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnSupplyChainIssueManagement();
        supplyChainIssueMgmtPage.clickOnVersionTab();
        String buyerAdminAppLocalVersion =  supplyChainIssueMgmtPage.getAppLocalVersion();
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        String versionColumn = "Version";
        userManagementPage.clickOnColumnSelectionIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        userManagementPage.selectColumnFields1(versionColumn);
        driver.sleep(WaitTime.SMALL_WAIT);
        userManagementPage.clickOnColumnSelectionCloseButton();
        ProblemCasePage problemCasePage = new ProblemCasePage(driver);
        String problemType = "1";
        String primaryNonConformance = "1";
        String secondaryNonConformance = "1";
        String part = "1";
        String buyerLocation = "1";
        String caseStatus = "open";
        String priority = "P1";
        String supplierLocation = "1";
        String supplier = "1";
        String shortDescription = RandomDataUtils.randomNumeric(5);
        problemCasePage.createProblemCase(problemType, primaryNonConformance, secondaryNonConformance, part, buyerLocation, caseStatus, priority, supplierLocation, shortDescription, supplier);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        String problemCaseId = problemCasePage.getProblemCaseId();
        String conversationComment = RandomDataUtils.randomAlphabetic(5);
        String problemDescription = RandomDataUtils.randomAlphabetic(5);
        String productionPhase = "1";
        String problemQualifier = "1";
        String submittedSupplierStatus = "Submitted to Supplier";
        problemCasePage.editProblemCase(conversationComment, problemDescription, productionPhase, problemQualifier, submittedSupplierStatus);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseCreatedAndEdited = problemCasePage.isProblemCaseDisplayed(problemCaseId, submittedSupplierStatus);
        softAssert.assertTrue(isProblemCaseCreatedAndEdited, "Failed to create and edit problem case");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        userManagementPage.clickOnColumnSelectionIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        userManagementPage.selectColumnFields1(versionColumn);
        driver.sleep(WaitTime.SMALL_WAIT);
        userManagementPage.clickOnColumnSelectionCloseButton();
        boolean isProblemCaseDisplayedWithSubmittedSupplierStatus = problemCasePage.isProblemCaseDisplayed(problemCaseId, submittedSupplierStatus, buyerAdminAppLocalVersion);
        softAssert.assertTrue(isProblemCaseDisplayedWithSubmittedSupplierStatus, "Failed to display problem case version with Submitted to Supplier status in supplier admin");
        homePage.clickOnToDosButton();
        driver.sleep(WaitTime.LONG_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseDisplayedWithSubmittedSupplierStatusToDoList = problemCasePage.isProblemCaseDisplayed(problemCaseId, submittedSupplierStatus, buyerAdminAppLocalVersion);
        softAssert.assertTrue(isProblemCaseDisplayedWithSubmittedSupplierStatusToDoList, "Failed to display problem case version with Submitted to Supplier status in supplier admin in to do's list");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-1783"})
    @Test
    public void verifyProblemCaseVersionInBuyerAdminLogin() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        login.loginWithBuyerUser(testContext.app);
        HomePage homePage = new HomePage(driver);
        homePage.clickOnSupplyChainIssueManagement();
        ProblemCasePage problemCasePage = new ProblemCasePage(driver);
        UserManagementPage userManagementPage = new UserManagementPage(driver);
        String problemType = "1";
        String primaryNonConformance = "1";
        String secondaryNonConformance = "1";
        String part = "1";
        String buyerLocation = "1";
        String caseStatus = "open";
        String priority = "P1";
        String supplierLocation = "1";
        String supplier = "1";
        String shortDescription = RandomDataUtils.randomNumeric(5);
        problemCasePage.createProblemCase(problemType, primaryNonConformance, secondaryNonConformance, part, buyerLocation, caseStatus, priority, supplierLocation, shortDescription, supplier);
        driver.sleep(WaitTime.LONG_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.LONG_WAIT);
        String problemCaseId = problemCasePage.getProblemCaseId();
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnHome();
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        String selectColumn = "Version";
        userManagementPage.clickOnColumnSelectionIcon();
        driver.sleep(WaitTime.XSMALL_WAIT);
        userManagementPage.selectColumnFields(selectColumn);
        userManagementPage.clickOnColumnSelectionCloseButton();
        String problemCaseVersion =  problemCasePage.getProblemCaseVersion(problemCaseId, "Open Problem Case");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        login.loginWithBuyerAdmin(testContext.app);
        homePage.clickOnProject();
        driver.sleep(WaitTime.SMALL_WAIT);
        homePage.clickOnSupplyChainIssueManagement();
        SupplyChainIssueMgmtPage supplyChainIssueMgmtPage = new SupplyChainIssueMgmtPage(driver);
        driver.sleep(WaitTime.SMALL_WAIT);
        supplyChainIssueMgmtPage.clickOnVersionTab();
        String appLocalNewVersion =  supplyChainIssueMgmtPage.getAppLocalVersion();
        softAssert.assertEquals(appLocalNewVersion, problemCaseVersion, "Failed to display problem case version in buyer admin version tab");
        supplyChainIssueMgmtPage.clickOnDeleteButton(problemCaseVersion);
        supplyChainIssueMgmtPage.clickOnDeleteDialogYesButton();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        boolean isDeletedVersionDisplayed = supplyChainIssueMgmtPage.isAppVersionDisplayed(problemCaseVersion);
        softAssert.assertTrue(isDeletedVersionDisplayed, "Able to delete version");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-2464"})
    @Test
    public void verifyExportToTenantOptionForProblemCases() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        HomePage homePage = new HomePage(driver);
        BusinessOrganizationsPage businessOrganizationsPage = new BusinessOrganizationsPage(driver);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.SMALL_WAIT);
        businessOrganizationsPage.clickOnTopLeftVerticalIcon();
        boolean isExportToTenantOptionDisplayed = businessOrganizationsPage.isExportToTenantOptionDisplayed();
        softAssert.assertFalse(isExportToTenantOptionDisplayed, "Export to Tenant option is displaying for Problem cases");
        softAssert.assertAll();
    }

    @TestCaseID(ids = {"IENT-3325" , "IENT-3326"})
    @Test
    public void verifyAssignToSelfOption() {
        SoftAssert softAssert = new SoftAssert();
        Login login = new Login(driver);
        HomePage homePage = new HomePage(driver);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        ProblemCasePage problemCasePage = new ProblemCasePage(driver);
        String problemType = "1";
        String primaryNonConformance = "1";
        String secondaryNonConformance = "1";
        String part = "1";
        String buyerLocation = "1";
        String caseStatus = "inProcess";
        String priority = "P1";
        String supplierLocation = "1";
        String supplier = "1";
        String shortDescription = RandomDataUtils.randomNumeric(5);
        problemCasePage.createProblemCase(problemType, primaryNonConformance, secondaryNonConformance, part, buyerLocation, caseStatus, priority, supplierLocation, shortDescription, supplier);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        String problemCaseId = problemCasePage.getProblemCaseId();
        String conversationComment = RandomDataUtils.randomAlphabetic(5);
        String problemDescription = RandomDataUtils.randomAlphabetic(5);
        String productionPhase = "1";
        String problemQualifier = "1";
        String submittedSupplierStatus = "Submitted to Supplier";
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser2(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.clickOnCaseFormVerticalButton();
        driver.sleep(WaitTime.XSMALL_WAIT);
        problemCasePage.assignToSelf();
        String buyerUserName = testContext.app.getBuyerUser();
        String supplierAdminName = testContext.app.getSupplierAdminUser();
        String buyerUserName2 = testContext.app.getBuyerUser2();
        problemCasePage.clickOnHistoryTab();
        driver.sleep(WaitTime.XSMALL_WAIT);
        boolean isProblemCaseHistoryDisplayed = problemCasePage.isProblemCaseHistoryDisplayedForAssignToSelf(buyerUserName2);
        softAssert.assertTrue(isProblemCaseHistoryDisplayed, "Failed to generate problem case history for assign to self");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithBuyerUser(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        driver.sleep(WaitTime.XSMALL_WAIT);
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.goToEditView();
        boolean isProblemCaseEditable = problemCasePage.isSaveAndCancelButtonDisplayed();
        softAssert.assertFalse(isProblemCaseEditable, "Failed to restrict BU to edit case without assigning himself");
        problemCasePage.clickOnCaseFormVerticalButton();
        driver.sleep(WaitTime.XSMALL_WAIT);
        problemCasePage.assignToSelf();
        problemCasePage.editProblemCase(conversationComment, problemDescription, productionPhase, problemQualifier, submittedSupplierStatus);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isProblemCaseStatusUpdated = problemCasePage.isProblemCaseDisplayed(problemCaseId, submittedSupplierStatus);
        softAssert.assertTrue(isProblemCaseStatusUpdated, "Failed to update status of problem case");
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.clickOnHistoryTab();
        boolean isProblemCaseUpdateHistoryDisplayed = problemCasePage.isProblemCaseHistoryDisplayedForAssignToSelf(buyerUserName);
        softAssert.assertTrue(isProblemCaseUpdateHistoryDisplayed, "Failed to generate problem case log for assign to self");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierUser(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.goToEditView();
        boolean isCaseEditableBeforeAssignedToSU = problemCasePage.isSaveAndCancelButtonDisplayed();
        softAssert.assertFalse(isCaseEditableBeforeAssignedToSU, "Failed to restrict SU to edit case without assigning himself");
        problemCasePage.clickOnCaseFormVerticalButton();
        driver.sleep(WaitTime.XSMALL_WAIT);
        problemCasePage.assignToSelf();
        problemCasePage.goToEditView();
        boolean isCaseEditableAfterAssignedToSU = problemCasePage.isSaveAndCancelButtonDisplayed();
        softAssert.assertTrue(isCaseEditableAfterAssignedToSU, "Failed to edit case after assigning himself by SU");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierAdmin(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.goToEditView();
        boolean isCaseEditableBeforeAssignedToSA = problemCasePage.isSaveAndCancelButtonDisplayed();
        softAssert.assertFalse(isCaseEditableBeforeAssignedToSA, "Failed to restrict SA to edit case without assigning himself");
        problemCasePage.clickOnCaseFormVerticalButton();
        driver.sleep(WaitTime.XSMALL_WAIT);
        problemCasePage.assignToSelf();
        problemCasePage.goToEditView();
        boolean isCaseEditableAfterAssignedToSA = problemCasePage.isSaveAndCancelButtonDisplayed();
        softAssert.assertTrue(isCaseEditableAfterAssignedToSA, "Failed to edit case after assigning himself by SA");
        problemCasePage.clickOnHistoryTab();
        boolean isProblemCaseAssignHistoryDisplayed_SA = problemCasePage.isProblemCaseHistoryDisplayedForAssignToSelf(supplierAdminName);
        softAssert.assertTrue(isProblemCaseAssignHistoryDisplayed_SA, "Failed to generate log for assigning to self");
        homePage.clickOnAdminDropDownLink();
        homePage.clickOnLogoutLink();
        driver.sleep(WaitTime.SMALL_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.SMALL_WAIT);
        login.loginWithSupplierUser(testContext.app);
        homePage.clickOnSupplyChainIssueManagement();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        String initialResponseFromSupplierStatus = "Initial response from supplier";
        String initialResponseFromTheSupplierStatus = "Initial response from the supplier";
        problemCasePage.viewProblemCase();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.clickOnCaseFormVerticalButton();
        problemCasePage.assignToSelf();
        problemCasePage.editProblemCase(conversationComment, initialResponseFromSupplierStatus);
        driver.sleep(WaitTime.MEDIUM_WAIT);
        driver.refresh();
        driver.sleep(WaitTime.MEDIUM_WAIT);
        problemCasePage.searchProblemCaseByID(problemCaseId);
        boolean isCaseDisplayedWithInitialResponseFromSupplierStatus = problemCasePage.isProblemCaseDisplayed(problemCaseId, initialResponseFromTheSupplierStatus);
        softAssert.assertTrue(isCaseDisplayedWithInitialResponseFromSupplierStatus, "Failed to update status to Initial response from supplier");
        softAssert.assertAll();
    }

}
